SystemOrganization addCategory: #'SBE-Quinto'!

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell methodsFor: 'initialization' stamp: 'rm 1/18/2014 21:09'!
initialize
	"comment stating purpose of message"

	super initialize.
	self label:''.
	self borderWidth:2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!SBECell methodsFor: 'accessing' stamp: 'rm 1/18/2014 21:41'!
mouseAction: aBlock
	"comment stating purpose of message"

	^mouseAction:=aBlock! !

!SBECell methodsFor: 'event handling' stamp: 'rm 1/18/2014 21:45'!
mouseUp: anEvent
	"comment stating purpose of message"
	self toggleState.
	mouseAction value! !

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame methodsFor: 'initialization' stamp: 'rm 1/18/2014 21:23'!
cellsPerSide
	"comment stating purpose of message"

	^10! !

!SBEGame methodsFor: 'initialization' stamp: 'rm 1/18/2014 21:47'!
initialize
	"comment stating purpose of message"

	|sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n)@(height*n))+(2*self borderWidth)).
	cells := Matrix new: n tabulate: [:i :j |self newCellAt:i at:j].
	! !

!SBEGame methodsFor: 'initialization' stamp: 'rm 1/18/2014 21:46'!
newCellAt:i at:j
	"comment stating purpose of message"
	
	|c origin|
	
	c:= SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i-1)*c width) @ ((j-1)* c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt:i at:j].
	^c! !

!SBEGame methodsFor: 'game logic' stamp: 'rm 1/18/2014 21:36'!
toggleNeighboursOfCellAt:i at:j
	"comment stating purpose of message"

	(i>1) ifTrue:[(cells at:i-1 at:j) toggleState].	
	(i<self cellsPerSide) ifTrue:[(cells at:i+1 at:j) toggleState].	
	(j>1) ifTrue:[(cells at:i at:j-1) toggleState].
	(j<self cellsPerSide) ifTrue:[(cells at:i at:j+1) toggleState]! !
